import java.util.ArrayList;

public class ElementContainer {
  private Element elem;
  private ElementContainer child;
  private static final int array_size = 1000;
  private static double combinations[][] = new double[2][array_size];
  private static int index=0;
  
// Three constructors to allow three different ways of initialising.
  public ElementContainer(Element elem, ElementContainer child) {
    this.elem = elem;
    this.child = child;
  }

  public ElementContainer(Element elem) {
    this.elem = elem;
    this.child = null;
  }
  
  public ElementContainer(){
      this.elem = null;
      this.child = null;
  }

// Set the element of this container.
  public void setElem(Element elem) {
    this.elem = elem;
  }

// Set the child element of this container.
  public void setChild(ElementContainer child) {
    this.child = child;
  }
  
  public ElementContainer getChild()
  {
    return child;
  }

  public double[][] calculate() {
      double[][] combos;
      combos = start(0,100);
      combinations = new double[2][array_size];
      index = 0;
      return combos;
    }

  private double[][] start(double currentMass, double abundance) {
    int i;

    for (i=0; i<(elem.getIsotopes().count()); i++) { //for every isotope
      currentMass = currentMass + elem.getIsotopes().getIsotope(i).getAtomicMass(); //add mass
      
      abundance = abundance * elem.getIsotopes().getIsotope(i).getPercent();

      if (child != null) {
        child.start(currentMass, abundance); //pass everything to the child and repeat
      }
      else {
        combinations[0][index]=currentMass;
        combinations[1][index]=abundance;
        index++;
      }
      //subtract previous isotope's mass, ready for the next isotope of this element.
      currentMass = currentMass - elem.getIsotopes().getIsotope(i).getAtomicMass();

      abundance = abundance / elem.getIsotopes().getIsotope(i).getPercent();
    }
    return combinations;
  }
}