import java.util.Vector;

/**
 * <p>
 * Represents a list of isotopes, each elements has its own list of isotopes.
 * </p>
 * <p>
 * Encapsulates a Vector
 * </p>
 * 
 * @author Team NAH
 */
public class IsotopeList {
	private Vector vIsotopes;

	/**
	 * Constructor
	 * 
	 * @param n
	 *            initial size to set the vector to
	 */
	public IsotopeList(int n) {
		vIsotopes = new Vector(n);
	}

	/**
	 * @param iso
	 *            element to add to the list
	 */
	public void add(Isotope iso) {
		vIsotopes.addElement(iso);
	}

	/**
	 * @param iso
	 *            element to remove from list
	 */
	public void remove(Isotope iso) {
		vIsotopes.remove(iso);
	}

	/**
	 * @return size of vector
	 */
	public int count() {
		return vIsotopes.size();
	}

	/**
	 * @param i
	 *            index of element wanted
	 * @return the wanted element
	 */
	public Isotope getIsotope(int i) {
		return (Isotope) vIsotopes.get(i);
	}

	/**
	 * converts this isotope list to an array of isotopes
	 */
	public Isotope[] toArray() {
		Isotope[] tmp = new Isotope[count()];
		return (Isotope[]) vIsotopes.toArray(tmp);
	}
}
