import javax.swing.JLabel;

public class UIErrorObserver extends JLabel implements IErrorObserver, Runnable {
	private static final long serialVersionUID = 8558999365445986584L;

	public static final int UIErrorID = 10;

	private int error_count = 0;

	/**
	 * Resets the text to ""
	 */
	public void run() {
		try {
			Thread.currentThread().sleep(10000);
		} catch (Exception e) {
		}

		if (error_count_op(-1))
			this.setText("");
	}

	/**
	 * manages changing the value of the <tt>error_count</tt> variable
	 * 
	 * @param op,
	 *            usualy <tt>1</tt> or <tt>-1</tt>
	 * @return true if <tt>error_count <= 0</tt>
	 */
	private synchronized boolean error_count_op(int op) {
		error_count += op;
		return error_count <= 0;
	}

	/**
	 * sets the error on the label and increments the error counter
	 */
	public void handleError(int errorID, String msg) {
		if (errorID == UIErrorID) {
			this.setText(msg);
			error_count_op(1);
			Thread t = new Thread(this);
			t.start();
		}
	}

}
